Code

Merge branch 'jk/maint-stash-oob'
[git.git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6    or: $dashless show [<stash>]
7    or: $dashless drop [-q|--quiet] [<stash>]
8    or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9    or: $dashless branch <branchname> [<stash>]
10    or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
11    or: $dashless clear"
13 SUBDIRECTORY_OK=Yes
14 OPTIONS_SPEC=
15 START_DIR=`pwd`
16 . git-sh-setup
17 require_work_tree
18 cd_to_toplevel
20 TMP="$GIT_DIR/.git-stash.$$"
21 TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
22 trap 'rm -f "$TMP-"* "$TMPindex"' 0
24 ref_stash=refs/stash
26 if git config --get-colorbool color.interactive; then
27        help_color="$(git config --get-color color.interactive.help 'red bold')"
28        reset_color="$(git config --get-color '' reset)"
29 else
30        help_color=
31        reset_color=
32 fi
34 no_changes () {
35         git diff-index --quiet --cached HEAD --ignore-submodules -- &&
36         git diff-files --quiet --ignore-submodules
37 }
39 clear_stash () {
40         if test $# != 0
41         then
42                 die "git stash clear with parameters is unimplemented"
43         fi
44         if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
45         then
46                 git update-ref -d $ref_stash $current
47         fi
48 }
50 create_stash () {
51         stash_msg="$1"
53         git update-index -q --refresh
54         if no_changes
55         then
56                 exit 0
57         fi
59         # state of the base commit
60         if b_commit=$(git rev-parse --verify HEAD)
61         then
62                 head=$(git rev-list --oneline -n 1 HEAD --)
63         else
64                 die "You do not have the initial commit yet"
65         fi
67         if branch=$(git symbolic-ref -q HEAD)
68         then
69                 branch=${branch#refs/heads/}
70         else
71                 branch='(no branch)'
72         fi
73         msg=$(printf '%s: %s' "$branch" "$head")
75         # state of the index
76         i_tree=$(git write-tree) &&
77         i_commit=$(printf 'index on %s\n' "$msg" |
78                 git commit-tree $i_tree -p $b_commit) ||
79                 die "Cannot save the current index state"
81         if test -z "$patch_mode"
82         then
84                 # state of the working tree
85                 w_tree=$( (
86                         git read-tree --index-output="$TMPindex" -m $i_tree &&
87                         GIT_INDEX_FILE="$TMPindex" &&
88                         export GIT_INDEX_FILE &&
89                         git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
90                         git write-tree &&
91                         rm -f "$TMPindex"
92                 ) ) ||
93                         die "Cannot save the current worktree state"
95         else
97                 rm -f "$TMP-index" &&
98                 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
100                 # find out what the user wants
101                 GIT_INDEX_FILE="$TMP-index" \
102                         git add--interactive --patch=stash -- &&
104                 # state of the working tree
105                 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
106                 die "Cannot save the current worktree state"
108                 git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
109                 test -s "$TMP-patch" ||
110                 die "No changes selected"
112                 rm -f "$TMP-index" ||
113                 die "Cannot remove temporary index (can't happen)"
115         fi
117         # create the stash
118         if test -z "$stash_msg"
119         then
120                 stash_msg=$(printf 'WIP on %s' "$msg")
121         else
122                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
123         fi
124         w_commit=$(printf '%s\n' "$stash_msg" |
125                 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
126                 die "Cannot record working tree state"
129 save_stash () {
130         keep_index=
131         patch_mode=
132         while test $# != 0
133         do
134                 case "$1" in
135                 -k|--keep-index)
136                         keep_index=t
137                         ;;
138                 --no-keep-index)
139                         keep_index=
140                         ;;
141                 -p|--patch)
142                         patch_mode=t
143                         keep_index=t
144                         ;;
145                 -q|--quiet)
146                         GIT_QUIET=t
147                         ;;
148                 --)
149                         shift
150                         break
151                         ;;
152                 -*)
153                         echo "error: unknown option for 'stash save': $1"
154                         echo "       To provide a message, use git stash save -- '$1'"
155                         usage
156                         ;;
157                 *)
158                         break
159                         ;;
160                 esac
161                 shift
162         done
164         stash_msg="$*"
166         git update-index -q --refresh
167         if no_changes
168         then
169                 say 'No local changes to save'
170                 exit 0
171         fi
172         test -f "$GIT_DIR/logs/$ref_stash" ||
173                 clear_stash || die "Cannot initialize stash"
175         create_stash "$stash_msg"
177         # Make sure the reflog for stash is kept.
178         : >>"$GIT_DIR/logs/$ref_stash"
180         git update-ref -m "$stash_msg" $ref_stash $w_commit ||
181                 die "Cannot save the current status"
182         say Saved working directory and index state "$stash_msg"
184         if test -z "$patch_mode"
185         then
186                 git reset --hard ${GIT_QUIET:+-q}
188                 if test -n "$keep_index" && test -n $i_tree
189                 then
190                         git read-tree --reset -u $i_tree
191                 fi
192         else
193                 git apply -R < "$TMP-patch" ||
194                 die "Cannot remove worktree changes"
196                 if test -z "$keep_index"
197                 then
198                         git reset
199                 fi
200         fi
203 have_stash () {
204         git rev-parse --verify $ref_stash >/dev/null 2>&1
207 list_stash () {
208         have_stash || return 0
209         git log --format="%gd: %gs" -g "$@" $ref_stash --
212 show_stash () {
213         assert_stash_like "$@"
215         git diff ${FLAGS:---stat} $b_commit $w_commit
219 # Parses the remaining options looking for flags and
220 # at most one revision defaulting to ${ref_stash}@{0}
221 # if none found.
223 # Derives related tree and commit objects from the
224 # revision, if one is found.
226 # stash records the work tree, and is a merge between the
227 # base commit (first parent) and the index tree (second parent).
229 #   REV is set to the symbolic version of the specified stash-like commit
230 #   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
231 #   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
232 #   s is set to the SHA1 of the stash commit
233 #   w_commit is set to the commit containing the working tree
234 #   b_commit is set to the base commit
235 #   i_commit is set to the commit containing the index tree
236 #   w_tree is set to the working tree
237 #   b_tree is set to the base tree
238 #   i_tree is set to the index tree
240 #   GIT_QUIET is set to t if -q is specified
241 #   INDEX_OPTION is set to --index if --index is specified.
242 #   FLAGS is set to the remaining flags
244 # dies if:
245 #   * too many revisions specified
246 #   * no revision is specified and there is no stash stack
247 #   * a revision is specified which cannot be resolve to a SHA1
248 #   * a non-existent stash reference is specified
251 parse_flags_and_rev()
253         test "$PARSE_CACHE" = "$*" && return 0 # optimisation
254         PARSE_CACHE="$*"
256         IS_STASH_LIKE=
257         IS_STASH_REF=
258         INDEX_OPTION=
259         s=
260         w_commit=
261         b_commit=
262         i_commit=
263         w_tree=
264         b_tree=
265         i_tree=
267         REV=$(git rev-parse --no-flags --symbolic "$@") || exit 1
269         FLAGS=
270         for opt
271         do
272                 case "$opt" in
273                         -q|--quiet)
274                                 GIT_QUIET=-t
275                         ;;
276                         --index)
277                                 INDEX_OPTION=--index
278                         ;;
279                         -*)
280                                 FLAGS="${FLAGS}${FLAGS:+ }$opt"
281                         ;;
282                 esac
283         done
285         set -- $REV
287         case $# in
288                 0)
289                         have_stash || die "No stash found."
290                         set -- ${ref_stash}@{0}
291                 ;;
292                 1)
293                         :
294                 ;;
295                 *)
296                         die "Too many revisions specified: $REV"
297                 ;;
298         esac
300         REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"
302         i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
303         set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
304         s=$1 &&
305         w_commit=$1 &&
306         b_commit=$2 &&
307         w_tree=$3 &&
308         b_tree=$4 &&
309         i_tree=$5 &&
310         IS_STASH_LIKE=t &&
311         test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
312         IS_STASH_REF=t
315 is_stash_like()
317         parse_flags_and_rev "$@"
318         test -n "$IS_STASH_LIKE"
321 assert_stash_like() {
322         is_stash_like "$@" || die "'$*' is not a stash-like commit"
325 is_stash_ref() {
326         is_stash_like "$@" && test -n "$IS_STASH_REF"
329 assert_stash_ref() {
330         is_stash_ref "$@" || die "'$*' is not a stash reference"
333 apply_stash () {
335         assert_stash_like "$@"
337         git update-index -q --refresh || die 'unable to refresh index'
339         # current index state
340         c_tree=$(git write-tree) ||
341                 die 'Cannot apply a stash in the middle of a merge'
343         unstashed_index_tree=
344         if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
345                         test "$c_tree" != "$i_tree"
346         then
347                 git diff-tree --binary $s^2^..$s^2 | git apply --cached
348                 test $? -ne 0 &&
349                         die 'Conflicts in index. Try without --index.'
350                 unstashed_index_tree=$(git write-tree) ||
351                         die 'Could not save index tree'
352                 git reset
353         fi
355         eval "
356                 GITHEAD_$w_tree='Stashed changes' &&
357                 GITHEAD_$c_tree='Updated upstream' &&
358                 GITHEAD_$b_tree='Version stash was based on' &&
359                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
360         "
362         if test -n "$GIT_QUIET"
363         then
364                 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
365         fi
366         if git merge-recursive $b_tree -- $c_tree $w_tree
367         then
368                 # No conflict
369                 if test -n "$unstashed_index_tree"
370                 then
371                         git read-tree "$unstashed_index_tree"
372                 else
373                         a="$TMP-added" &&
374                         git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
375                         git read-tree --reset $c_tree &&
376                         git update-index --add --stdin <"$a" ||
377                                 die "Cannot unstage modified files"
378                         rm -f "$a"
379                 fi
380                 squelch=
381                 if test -n "$GIT_QUIET"
382                 then
383                         squelch='>/dev/null 2>&1'
384                 fi
385                 (cd "$START_DIR" && eval "git status $squelch") || :
386         else
387                 # Merge conflict; keep the exit status from merge-recursive
388                 status=$?
389                 if test -n "$INDEX_OPTION"
390                 then
391                         echo >&2 'Index was not unstashed.'
392                 fi
393                 exit $status
394         fi
397 pop_stash() {
398         assert_stash_ref "$@"
400         apply_stash "$@" &&
401         drop_stash "$@"
404 drop_stash () {
405         assert_stash_ref "$@"
407         git reflog delete --updateref --rewrite "${REV}" &&
408                 say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
410         # clear_stash if we just dropped the last stash entry
411         git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
414 apply_to_branch () {
415         test -n "$1" || die 'No branch name specified'
416         branch=$1
417         shift 1
419         set -- --index "$@"
420         assert_stash_like "$@"
422         git checkout -b $branch $REV^ &&
423         apply_stash "$@" && {
424                 test -z "$IS_STASH_REF" || drop_stash "$@"
425         }
428 PARSE_CACHE='--not-parsed'
429 # The default command is "save" if nothing but options are given
430 seen_non_option=
431 for opt
432 do
433         case "$opt" in
434         -*) ;;
435         *) seen_non_option=t; break ;;
436         esac
437 done
439 test -n "$seen_non_option" || set "save" "$@"
441 # Main command set
442 case "$1" in
443 list)
444         shift
445         list_stash "$@"
446         ;;
447 show)
448         shift
449         show_stash "$@"
450         ;;
451 save)
452         shift
453         save_stash "$@"
454         ;;
455 apply)
456         shift
457         apply_stash "$@"
458         ;;
459 clear)
460         shift
461         clear_stash "$@"
462         ;;
463 create)
464         if test $# -gt 0 && test "$1" = create
465         then
466                 shift
467         fi
468         create_stash "$*" && echo "$w_commit"
469         ;;
470 drop)
471         shift
472         drop_stash "$@"
473         ;;
474 pop)
475         shift
476         pop_stash "$@"
477         ;;
478 branch)
479         shift
480         apply_to_branch "$@"
481         ;;
482 *)
483         case $# in
484         0)
485                 save_stash &&
486                 say '(To restore them type "git stash apply")'
487                 ;;
488         *)
489                 usage
490         esac
491         ;;
492 esac